"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
/*
  The MIT License
  
  Copyright (c) 2018 EclipseSource Munich
  https://github.com/eclipsesource/jsonforms
  
  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:
  
  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.
  
  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.
*/
var store_1 = require("@angular-redux/store");
var core_1 = require("@angular/core");
var angular_1 = require("@jsonforms/angular");
var core_2 = require("@jsonforms/core");
var map_1 = require("rxjs/operators/map");
var startWith_1 = require("rxjs/operators/startWith");
/**
 * To use this component you will need to add your own tester:
 * <pre><code>
 * ...
 * export const AutocompleteControlRendererTester: RankedTester = rankWith(2, isEnumControl);
 * ...
 * </code></pre>
 * Add the tester and renderer to JSONForms registry:
 * <pre><code>
 * ...
 * { tester: AutocompleteControlRendererTester, renderer: AutocompleteControlRenderer },
 * ...
 * </code></pre>
 * Furthermore you need to update your module.
 * <pre><code>
 * ...
 * imports: [JsonFormsAngularMaterialModule, MatAutocompleteModule],
 * declarations: [AutocompleteControlRenderer],
 * entryComponents: [AutocompleteControlRenderer]
 * ...
 * </code></pre>
 *
 */
var AutocompleteControlRenderer = /** @class */ (function (_super) {
    __extends(AutocompleteControlRenderer, _super);
    function AutocompleteControlRenderer(ngRedux) {
        var _this = _super.call(this, ngRedux) || this;
        _this.getEventValue = function (event) { return event.target.value; };
        return _this;
    }
    AutocompleteControlRenderer.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.shouldFilter = false;
        this.filteredOptions = this.form.valueChanges.pipe(startWith_1.startWith(''), map_1.map(function (val) { return _this.filter(val); }));
    };
    AutocompleteControlRenderer.prototype.updateFilter = function (event) {
        // ENTER
        if (event.keyCode === 13) {
            this.shouldFilter = false;
        }
        else {
            this.shouldFilter = true;
        }
    };
    AutocompleteControlRenderer.prototype.onSelect = function (ev) {
        var path = core_2.composeWithUi(this.uischema, this.path);
        this.shouldFilter = false;
        this.ngRedux.dispatch(core_2.Actions.update(path, function () { return ev.option.value; }));
        this.triggerValidation();
    };
    AutocompleteControlRenderer.prototype.filter = function (val) {
        var _this = this;
        return (this.options || this.scopedSchema.enum || []).filter(function (option) {
            return !_this.shouldFilter ||
                (!val || option.toLowerCase().indexOf(val.toLowerCase()) === 0);
        });
    };
    AutocompleteControlRenderer.prototype.getOwnProps = function () {
        return __assign({}, _super.prototype.getOwnProps.call(this), { options: this.options });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], AutocompleteControlRenderer.prototype, "options", void 0);
    AutocompleteControlRenderer = __decorate([
        core_1.Component({
            selector: 'AutocompleteControlRenderer',
            template: "\n    <mat-form-field fxFlex>\n      <mat-label>{{ label }}</mat-label>\n      <input\n        matInput\n        type=\"text\"\n        (change)=\"onChange($event)\"\n        placeholder=\"{{ description }}\"\n        [id]=\"id\"\n        [formControl]=\"form\"\n        [matAutocomplete]=\"auto\"\n        (keydown)=\"updateFilter($event)\"\n      />\n      <mat-autocomplete\n        autoActiveFirstOption\n        #auto=\"matAutocomplete\"\n        (optionSelected)=\"onSelect($event)\"\n      >\n        <mat-option\n          *ngFor=\"let option of (filteredOptions | async)\"\n          [value]=\"option\"\n        >\n          {{ option }}\n        </mat-option>\n      </mat-autocomplete>\n      <mat-error>{{ error }}</mat-error>\n    </mat-form-field>\n  "
        }),
        __metadata("design:paramtypes", [store_1.NgRedux])
    ], AutocompleteControlRenderer);
    return AutocompleteControlRenderer;
}(angular_1.JsonFormsControl));
exports.AutocompleteControlRenderer = AutocompleteControlRenderer;
exports.enumControlTester = core_2.rankWith(2, core_2.isEnumControl);
//# sourceMappingURL=autocomplete.renderer.js.map