"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var store_1 = require("@angular-redux/store");
var core_2 = require("@jsonforms/core");
var angular_1 = require("@jsonforms/angular");
var material_1 = require("@angular/material");
var DateControlRenderer = /** @class */ (function (_super) {
    __extends(DateControlRenderer, _super);
    function DateControlRenderer(ngRedux, dateAdapter) {
        var _this = _super.call(this, ngRedux) || this;
        _this.dateAdapter = dateAdapter;
        _this.getEventValue = function (event) { return event.value.toISOString().substr(0, 10); };
        return _this;
    }
    DateControlRenderer.prototype.mapAdditionalProps = function () {
        var locale = core_2.getLocale(this.ngRedux.getState());
        this.dateAdapter.setLocale(locale);
    };
    DateControlRenderer = __decorate([
        core_1.Component({
            selector: 'DateControlRenderer',
            template: "\n    <mat-form-field fxFlex [fxHide]=\"hidden\">\n      <mat-label>{{ label }}</mat-label>\n      <input\n        matInput\n        (dateChange)=\"onChange($event)\"\n        placeholder=\"{{ description }}\"\n        [id]=\"id\"\n        [formControl]=\"form\"\n        [matDatepicker]=\"datepicker\"\n      />\n      <mat-datepicker-toggle\n        matSuffix\n        [for]=\"datepicker\"\n      ></mat-datepicker-toggle>\n      <mat-datepicker #datepicker></mat-datepicker>\n\n      <mat-error>{{ error }}</mat-error>\n    </mat-form-field>\n  "
        }),
        __metadata("design:paramtypes", [store_1.NgRedux,
            material_1.DateAdapter])
    ], DateControlRenderer);
    return DateControlRenderer;
}(angular_1.JsonFormsControl));
exports.DateControlRenderer = DateControlRenderer;
exports.DateControlRendererTester = core_2.rankWith(2, core_2.isDateControl);
//# sourceMappingURL=date.renderer.js.map