"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var angular_1 = require("@jsonforms/angular");
var core_1 = require("@jsonforms/core");
var LayoutRenderer = /** @class */ (function (_super) {
    __extends(LayoutRenderer, _super);
    function LayoutRenderer(ngRedux) {
        var _this = _super.call(this) || this;
        _this.ngRedux = ngRedux;
        return _this;
    }
    LayoutRenderer.prototype.ngOnInit = function () {
        var _this = this;
        this.subscription = this.ngRedux
            .select()
            .subscribe(function (state) {
            var props = core_1.mapStateToLayoutProps(state, _this.getOwnProps());
            _this.hidden = !props.visible;
        });
    };
    LayoutRenderer.prototype.ngOnDestroy = function () {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    };
    Object.defineProperty(LayoutRenderer.prototype, "renderProps", {
        get: function () {
            var _this = this;
            var elements = (this.uischema.elements || []).map(function (el) { return ({
                uischema: el,
                schema: _this.schema,
                path: _this.path
            }); });
            return elements;
        },
        enumerable: true,
        configurable: true
    });
    LayoutRenderer.prototype.trackElement = function (_index, renderProp) {
        return renderProp
            ? renderProp.path + JSON.stringify(renderProp.uischema)
            : null;
    };
    return LayoutRenderer;
}(angular_1.JsonFormsBaseRenderer));
exports.LayoutRenderer = LayoutRenderer;
//# sourceMappingURL=layout.renderer.js.map