"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
/*
  The MIT License
  
  Copyright (c) 2018 EclipseSource Munich
  https://github.com/eclipsesource/jsonforms
  
  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:
  
  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.
  
  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.
*/
var common_1 = require("@angular/common");
var core_1 = require("@angular/core");
var flex_layout_1 = require("@angular/flex-layout");
var forms_1 = require("@angular/forms");
var material_1 = require("@angular/material");
var animations_1 = require("@angular/platform-browser/animations");
var angular_1 = require("@jsonforms/angular");
var angular_l10n_1 = require("angular-l10n");
var controls_1 = require("./controls");
var other_1 = require("./other");
var layouts_1 = require("./layouts");
var emptyL10NConfig = {};
var JsonFormsAngularMaterialModule = /** @class */ (function () {
    function JsonFormsAngularMaterialModule() {
    }
    JsonFormsAngularMaterialModule = __decorate([
        core_1.NgModule({
            imports: [
                animations_1.BrowserAnimationsModule,
                common_1.CommonModule,
                angular_1.JsonFormsModule,
                material_1.MatFormFieldModule,
                material_1.MatCheckboxModule,
                material_1.MatInputModule,
                material_1.MatSliderModule,
                material_1.MatSlideToggleModule,
                material_1.MatNativeDateModule,
                material_1.MatDatepickerModule,
                material_1.MatTabsModule,
                material_1.MatSidenavModule,
                material_1.MatListModule,
                forms_1.ReactiveFormsModule,
                flex_layout_1.FlexLayoutModule,
                material_1.MatCardModule,
                material_1.MatSelectModule,
                material_1.MatButtonModule,
                material_1.MatIconModule,
                material_1.MatAutocompleteModule,
                angular_l10n_1.LocalizationModule,
                angular_l10n_1.LocaleValidationModule.forRoot(),
                angular_l10n_1.TranslationModule.forRoot(emptyL10NConfig)
            ],
            declarations: [
                controls_1.BooleanControlRenderer,
                controls_1.TextAreaRenderer,
                controls_1.TextControlRenderer,
                controls_1.NumberControlRenderer,
                controls_1.RangeControlRenderer,
                controls_1.DateControlRenderer,
                controls_1.ToggleControlRenderer,
                layouts_1.VerticalLayoutRenderer,
                layouts_1.HorizontalLayoutRenderer,
                layouts_1.CategorizationTabLayoutRenderer,
                layouts_1.GroupLayoutRenderer,
                other_1.LabelRenderer,
                other_1.MasterListComponent,
                other_1.JsonFormsDetailComponent,
                other_1.ObjectControlRenderer,
                controls_1.AutocompleteControlRenderer
            ],
            entryComponents: [
                controls_1.BooleanControlRenderer,
                controls_1.TextAreaRenderer,
                controls_1.TextControlRenderer,
                controls_1.NumberControlRenderer,
                controls_1.RangeControlRenderer,
                controls_1.DateControlRenderer,
                controls_1.ToggleControlRenderer,
                layouts_1.VerticalLayoutRenderer,
                layouts_1.HorizontalLayoutRenderer,
                layouts_1.GroupLayoutRenderer,
                other_1.LabelRenderer,
                layouts_1.CategorizationTabLayoutRenderer,
                other_1.MasterListComponent,
                other_1.JsonFormsDetailComponent,
                other_1.ObjectControlRenderer,
                controls_1.AutocompleteControlRenderer
            ],
            exports: [
                animations_1.BrowserAnimationsModule,
                common_1.CommonModule,
                angular_1.JsonFormsModule,
                material_1.MatFormFieldModule,
                material_1.MatCheckboxModule,
                material_1.MatInputModule,
                material_1.MatSliderModule,
                material_1.MatSlideToggleModule,
                material_1.MatNativeDateModule,
                material_1.MatDatepickerModule,
                material_1.MatTabsModule,
                material_1.MatSidenavModule,
                material_1.MatListModule,
                forms_1.ReactiveFormsModule,
                flex_layout_1.FlexLayoutModule,
                material_1.MatCardModule,
                material_1.MatSelectModule,
                material_1.MatButtonModule,
                material_1.MatIconModule,
                material_1.MatAutocompleteModule,
                angular_l10n_1.LocalizationModule,
                angular_l10n_1.LocaleValidationModule,
                angular_l10n_1.TranslationModule
            ],
            schemas: [core_1.CUSTOM_ELEMENTS_SCHEMA],
            providers: []
        })
    ], JsonFormsAngularMaterialModule);
    return JsonFormsAngularMaterialModule;
}());
exports.JsonFormsAngularMaterialModule = JsonFormsAngularMaterialModule;
//# sourceMappingURL=module.js.map